#include <nds.h>

#include "IPCFifo.h"


// ----- Global functions -----

// --------------------
void IrqVBlank()
{
}

// --------------------
int main(int argc, char **argv)
{
	irqInit();
	irqSet(IRQ_VBLANK, IrqVBlank);
	irqEnable(IRQ_VBLANK);

	IPCFifoInit();

	while(1)
	{
		u32 lastKeys = REG_KEYXY;

		swiWaitForVBlank();

		if (!(REG_KEYXY & BIT(0)) && (lastKeys & BIT(0)))
		{
			IPCFifoSendWord(FIFO_SUBSYSTEM_USER1, 0, 123);
			IPCFifoSendWordAsync(FIFO_SUBSYSTEM_USER1, 0, 456);
		}

		if (!(REG_KEYXY & BIT(1)) && (lastKeys & BIT(1)))
		{
			u32 data[4] = { 12, 34, 56, 78 };
			IPCFifoSendMulti(FIFO_SUBSYSTEM_USER1, 1, &data[0], 2);
			IPCFifoSendMultiAsync(FIFO_SUBSYSTEM_USER1, 1, &data[2], 2);
		}
	}

	return 0;
}
